<template>
    <div>
        <section class="hero is-transparent">
            <div class="hero-body">
                <div class="container has-text-centered">
                    <h1 class="title">
                        {{ $t('random.title') }}
                    </h1>
                    <h2 class="subtitle">
                        {{ $t('random.description') }}
                    </h2>
                </div>
            </div>
        </section>
        <br>
        <div class="container">
            <kara v-for="kara in karas" :key="kara.id" :kara="kara"></kara>
            <div class="container has-text-centered">
                <button class="button is-primary" :class="{'is-loading': loading}" @click="fetchKaras">
                    <span class="icon"><font-awesome-icon :icon="['fas', 'dice']"></font-awesome-icon></span>
                    <span>{{ $t('random.relaunch') }}</span>
                </button>
            </div>
        </div>
        <first-time-modal></first-time-modal>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue';
    // @ts-ignore : WebStorm linter is complaining, please don't
    import Kara from '~/components/Kara.vue';
    // @ts-ignore : WebStorm linter is complaining, please don't
    import FirstTimeModal from "~/components/FirstTimeModal";

    export default Vue.extend({
        data() {
            return {
                loading: true,
                karas: {}
            }
        },

        components: {
            FirstTimeModal,
            Kara
        },

        methods: {
            async fetchKaras() {
                this.loading = true;
                let res = await this.$axios.get(`${process.env.APP_URL}/api/karas/random`);
                this.karas = res.data;
                this.loading = false;
            }
        },

        mounted() {
            this.$nextTick(() => {
                this.$nuxt.$loading.start();
            });
            this.fetchKaras();
        },

        watch: {
            loading(now, _old) {
                if (now) this.$nuxt.$loading.start();
                else this.$nuxt.$loading.finish();
            }
        }
    });
</script>

<style lang="scss">
section.hero.is-transparent {
    background-color: unset;
}
</style>
